//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"



#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Blue
#property indicator_color3 Red

#property indicator_level1 0.0
#property indicator_level2 50.0
#property indicator_level3 -50.0

extern string ________Long_Symbols________ = "";                    
extern string     Symbol1Long          = "EURJPY";
extern string     Symbol2Long          = "AUDJPY";
extern string     Symbol3Long          = "USDCHF";
extern string     Symbol4Long          = "NZDUSD";
extern string     Symbol5Long          = "USDCAD";
extern string     Symbol6Long          = "EURCHF";
extern string     Symbol7Long          = "GBPCHF";
extern string     Symbol8Long          = "GBPUSD";
extern string ________Short_Symbols________ = ""; 
extern string     Symbol1Short          = "EURUSD";
extern string     Symbol2Short          = "EURGBP";
extern string     Symbol3Short          = "EURAUD";
extern string     Symbol4Short          = "CHFJPY";
extern string     Symbol5Short          = "AUDUSD";
//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
//---
extern int n=7; //  
extern int Fmin=2;//2; //    .
extern int Fmax=128; //    .
//extern string sym="GBPUSD";
//extern string sym="EURUSD";
double aa0[];
double aa0_buy[];
double aa0_sell[];
double aa1[];
double aa2[];
double aa3[];
double aa4[];
double aa5[];
double aa6[];
double aa7[];
double aa8[];
double aa9[];
double aa10[];
double aa11[];
double aa12[];
double aa13[];
int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    if(StringFind(Symbol(),"m",0)>0)
   {
    Symbol1Long = Symbol1Long+"m";
    Symbol2Long = Symbol2Long+"m";
    Symbol3Long = Symbol3Long+"m";
    Symbol4Long = Symbol4Long+"m";
    Symbol5Long = Symbol5Long+"m";
    Symbol6Long = Symbol6Long+"m";
    Symbol7Long = Symbol7Long+"m";
    Symbol8Long = Symbol8Long+"m";

    Symbol1Short = Symbol1Short+"m";
    Symbol2Short = Symbol2Short+"m";
    Symbol3Short = Symbol3Short+"m";
    Symbol4Short = Symbol4Short+"m";
    Symbol5Short = Symbol5Short+"m";
   }      
//---- indicators
SetIndexStyle(0,DRAW_LINE,0,2);
SetIndexBuffer(0,Buffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Buffer3);

//---
   N=MathPow(2,n);
   ArrayResize(aa0,N);
   ArrayResize(aa0_buy,N);
   ArrayResize(aa0_sell,N);
   ArrayResize(aa1,N);
   ArrayResize(aa2,N);
   ArrayResize(aa3,N);
   ArrayResize(aa4,N);
   ArrayResize(aa5,N);
   ArrayResize(aa6,N);
   ArrayResize(aa7,N);
   ArrayResize(aa8,N);
   ArrayResize(aa9,N);
   ArrayResize(aa10,N);
   ArrayResize(aa11,N);
   ArrayResize(aa12,N);
   ArrayResize(aa13,N);                                    

if( Fmax>=N ) Fmax=N;
if( Fmin<=2 ) Fmin=2;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if( Bars<N) return(0);
   RefreshRates();
   //---
   for(int i=N-1; i>=0; i--) 
   { 
     aa1[i]=iClose(Symbol1Long,0,i); 
     aa2[i]=iClose(Symbol1Long,0,i); 
     aa3[i]=iClose(Symbol1Long,0,i); 
     aa4[i]=iClose(Symbol1Long,0,i); 
     aa5[i]=iClose(Symbol1Long,0,i); 
     aa6[i]=iClose(Symbol1Long,0,i); 
     aa7[i]=iClose(Symbol1Long,0,i); 
     aa8[i]=iClose(Symbol1Long,0,i); 
     aa9[i]=iClose(Symbol5Short,0,i); 
     aa10[i]=iClose(Symbol5Short,0,i); 
     aa11[i]=iClose(Symbol5Short,0,i); 
     aa12[i]=iClose(Symbol5Short,0,i); 
     aa13[i]=iClose(Symbol5Short,0,i); 
   }
   //---
   realfastfouriertransform(aa1, N, false);
   realfastfouriertransform(aa2, N, false);
   realfastfouriertransform(aa3, N, false);
   realfastfouriertransform(aa4, N, false);
   realfastfouriertransform(aa5, N, false);
   realfastfouriertransform(aa6, N, false);
   realfastfouriertransform(aa7, N, false);
   realfastfouriertransform(aa8, N, false);
   realfastfouriertransform(aa9, N, false);
   realfastfouriertransform(aa10, N, false);
   realfastfouriertransform(aa11, N, false);
   realfastfouriertransform(aa12, N, false);
   realfastfouriertransform(aa13, N, false);
   //---
   N=ArraySize(aa1);
   //Comment("n= ",N);
   //---
   for( i=0; i<=N-1; i++) 
   { 
      if( i<Fmin || i>Fmax) 
      { 
        aa1[i]=0.0; 
        aa2[i]=0.0; 
        aa3[i]=0.0; 
        aa4[i]=0.0; 
        aa5[i]=0.0; 
        aa6[i]=0.0; 
        aa7[i]=0.0; 
        aa8[i]=0.0; 
        aa9[i]=0.0; 
        aa10[i]=0.0; 
        aa11[i]=0.0; 
        aa12[i]=0.0; 
        aa13[i]=0.0;                                                                                                 
      }
      aa0[i]=aa1[i]+aa2[i]+aa3[i]+aa4[i]+aa5[i]+aa6[i]+aa7[i]+aa8[i]+aa9[i]+aa10[i]+aa11[i]+aa12[i]+aa13[i];
      aa0_buy[i]=aa1[i]+aa2[i]+aa3[i]+aa4[i]+aa5[i]+aa6[i]+aa7[i]+aa8[i];
      aa0_sell[i]=aa9[i]+aa10[i]+aa11[i]+aa12[i]+aa13[i];
   }
   //---
   realfastfouriertransform(aa0, N, true);
   //realfastfouriertransform(aa0_buy, N, true);
   //realfastfouriertransform(aa0_sell, N, true);
   //---
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   SetIndexDrawBegin(2,Bars-N);
   //---
   for( i=0; i<=N-1; i++)
   {
      Buffer1[i]=aa0[i];
      //Buffer2[i]=aa0_buy[i];
      //Buffer3[i]=aa0_sell[i];
   }
   //----
   return(0);
  }
//-------------------------------------------------------------------+